libzypp: zypp::sat::SolvableType< Derived > Class Template Reference

libzypp 17.38.15

zypp::sat::SolvableType< Derived > Class Template Reference
CRTP solutions

Base class for creating Solvable based types. More...

`#include <zypp/sat/SolvableType.h>`

## Public Member Functions
Solvable | satSolvable () const
| Return the corresponding sat::Solvable.
| operator bool () const
IdString | ident () const
ResKind | kind () const
bool | isKind (const ResKind &kind_r) const
template<class TRes>
bool | isKind () const
template<class TIterator>
bool | isKind (TIterator begin, TIterator end) const
std::string | name () const
Edition | edition () const
Arch | arch () const
IdString | vendor () const
Repository | repository () const
RepoInfo | repoInfo () const
bool | isSystem () const
bool | onSystemByUser () const
bool | onSystemByAuto () const
bool | identIsAutoInstalled () const
bool | multiversionInstall () const
bool | isNeedreboot () const
Capability | patternProvides () const
bool | isPatternPackage () const
Capability | productProvides () const
bool | isProductPackage () const
bool | isBlacklisted () const
bool | isRetracted () const
bool | isPtf () const
bool | isPtfMaster () const
bool | isPtfPackage () const
Date | buildtime () const
Date | installtime () const
std::string | asString () const
std::string | asUserString () const
bool | identical (const Solvable &rhs) const
template<class RDerived>
bool | identical (const SolvableType< RDerived > &rhs) const
bool | sameNVRA (const Solvable &rhs) const
template<class RDerived>
bool | sameNVRA (const SolvableType< RDerived > &rhs) const
Capabilities | dep_provides () const
Capabilities | dep_requires () const
Capabilities | dep_conflicts () const
Capabilities | dep_obsoletes () const
Capabilities | dep_recommends () const
Capabilities | dep_suggests () const
Capabilities | dep_enhances () const
Capabilities | dep_supplements () const
Capabilities | dep_prerequires () const
Capabilities | dep (Dep which_r) const
Capabilities | operator[] (Dep which_r) const
Capabilities | provides () const
Capabilities | conflicts () const
Capabilities | obsoletes () const
Capabilities | recommends () const
Capabilities | suggests () const
Capabilities | enhances () const
Capabilities | supplements () const
Capabilities | prerequires () const
CapabilitySet | providesNamespace (const std::string &namespace_r) const
CapabilitySet | valuesOfNamespace (const std::string &namespace_r) const
bool | supportsLocales () const
bool | supportsLocale (const Locale &locale_r) const
bool | supportsLocale (const LocaleSet &locales_r) const
bool | supportsRequestedLocales () const
LocaleSet | getSupportedLocales () const
CpeId | cpeId () const
unsigned | mediaNr () const
ByteCount | installSize () const
ByteCount | downloadSize () const
std::string | distribution () const
std::string | summary (const Locale &lang_r=Locale()) const
std::string | description (const Locale &lang_r=Locale()) const
std::string | insnotify (const Locale &lang_r=Locale()) const
std::string | delnotify (const Locale &lang_r=Locale()) const
std::string | licenseToConfirm (const Locale &lang_r=Locale()) const
bool | needToAcceptLicense () const
std::string | lookupStrAttribute (const SolvAttr &attr) const
std::string | lookupStrAttribute (const SolvAttr &attr, const Locale &lang_r) const
bool | lookupBoolAttribute (const SolvAttr &attr) const
detail::IdType | lookupIdAttribute (const SolvAttr &attr) const
unsigned long long | lookupNumAttribute (const SolvAttr &attr) const
unsigned long long | lookupNumAttribute (const SolvAttr &attr, unsigned long long notfound_r) const
CheckSum | lookupCheckSumAttribute (const SolvAttr &attr) const
OnMediaLocation | lookupLocation () const
Solvable::IdType | id () const

## Public Attributes
Capabilities | const { return satSolvable().dep_requires()

## Protected Member Functions
| SolvableType ()
| SolvableType (const SolvableType &)=default
SolvableType & | operator= (const SolvableType &)=default
| SolvableType (SolvableType &&) noexcept=default
SolvableType & | operator= (SolvableType &&) noexcept=default
| ~SolvableType ()

## Detailed Description

template<class Derived>
class zypp::sat::SolvableType< Derived >

Base class for creating Solvable based types.

Derive from this and offer explicit conversion to Solvable to make the Solvable properties directly accessible.

Different SolvableTypes are comparable based on the underlying Solvable.

See also
  Solvable

class MySolvable : public SolvableType<MySolvable>
{
......
public:
explicit operator sat::Solvable() const;
};
zypp::sat::Solvable
A Solvable object within the sat Pool.
Definition Solvable.h:54
zypp::sat::SolvableType::SolvableType
SolvableType()
Definition SolvableType.h:169

Definition at line 54 of file SolvableType.h.

## Constructor & Destructor Documentation

## ◆ SolvableType() [1/3]

template<class Derived>

zypp::sat::SolvableType< Derived >::SolvableType | ( |  | ) |
| inlineprotected

Definition at line 169 of file SolvableType.h.

## ◆ SolvableType() [2/3]

template<class Derived>

zypp::sat::SolvableType< Derived >::SolvableType | ( | const SolvableType< Derived > & |  | ) |
| protecteddefault

## ◆ SolvableType() [3/3]

template<class Derived>

zypp::sat::SolvableType< Derived >::SolvableType | ( | SolvableType< Derived > && |  | ) |
| protecteddefaultnoexcept

## ◆ ~SolvableType()

template<class Derived>

zypp::sat::SolvableType< Derived >::~SolvableType | ( |  | ) |
| inlineprotected

Definition at line 174 of file SolvableType.h.

## Member Function Documentation

## ◆ satSolvable()

template<class Derived>

Solvable zypp::sat::SolvableType< Derived >::satSolvable | ( |  | ) | const
| inline

Return the corresponding sat::Solvable.

Definition at line 57 of file SolvableType.h.

## ◆ operator bool()

template<class Derived>

zypp::sat::SolvableType< Derived >::operator bool | ( |  | ) | const
| inlineexplicit

Definition at line 59 of file SolvableType.h.

## ◆ ident()

template<class Derived>

IdString zypp::sat::SolvableType< Derived >::ident | ( |  | ) | const
| inline

Definition at line 61 of file SolvableType.h.

## ◆ kind()

template<class Derived>

ResKind zypp::sat::SolvableType< Derived >::kind | ( |  | ) | const
| inline

Definition at line 63 of file SolvableType.h.

## ◆ isKind() [1/3]

template<class Derived>

bool zypp::sat::SolvableType< Derived >::isKind | ( | const ResKind & | kind_r | ) | const
| inline

Definition at line 64 of file SolvableType.h.

## ◆ isKind() [2/3]

template<class Derived>
template<class TRes>

bool zypp::sat::SolvableType< Derived >::isKind | ( |  | ) | const
| inline

Definition at line 66 of file SolvableType.h.

## ◆ isKind() [3/3]

template<class Derived>
template<class TIterator>

bool zypp::sat::SolvableType< Derived >::isKind | ( | TIterator | begin,
|  | TIterator | end ) const
| inline

Definition at line 68 of file SolvableType.h.

## ◆ name()

template<class Derived>

std::string zypp::sat::SolvableType< Derived >::name | ( |  | ) | const
| inline

Definition at line 70 of file SolvableType.h.

## ◆ edition()

template<class Derived>

Edition zypp::sat::SolvableType< Derived >::edition | ( |  | ) | const
| inline

Definition at line 71 of file SolvableType.h.

## ◆ arch()

template<class Derived>

Arch zypp::sat::SolvableType< Derived >::arch | ( |  | ) | const
| inline

Definition at line 72 of file SolvableType.h.

## ◆ vendor()

template<class Derived>

IdString zypp::sat::SolvableType< Derived >::vendor | ( |  | ) | const
| inline

Definition at line 73 of file SolvableType.h.

## ◆ repository()

template<class Derived>

Repository zypp::sat::SolvableType< Derived >::repository | ( |  | ) | const
| inline

Definition at line 75 of file SolvableType.h.

## ◆ repoInfo()

template<class Derived>

RepoInfo zypp::sat::SolvableType< Derived >::repoInfo | ( |  | ) | const
| inline

Definition at line 76 of file SolvableType.h.

## ◆ isSystem()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::isSystem | ( |  | ) | const
| inline

Definition at line 78 of file SolvableType.h.

## ◆ onSystemByUser()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::onSystemByUser | ( |  | ) | const
| inline

Definition at line 79 of file SolvableType.h.

## ◆ onSystemByAuto()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::onSystemByAuto | ( |  | ) | const
| inline

Definition at line 80 of file SolvableType.h.

## ◆ identIsAutoInstalled()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::identIsAutoInstalled | ( |  | ) | const
| inline

Definition at line 81 of file SolvableType.h.

## ◆ multiversionInstall()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::multiversionInstall | ( |  | ) | const
| inline

Definition at line 82 of file SolvableType.h.

## ◆ isNeedreboot()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::isNeedreboot | ( |  | ) | const
| inline

Definition at line 83 of file SolvableType.h.

## ◆ patternProvides()

template<class Derived>

Capability zypp::sat::SolvableType< Derived >::patternProvides | ( |  | ) | const
| inline

Definition at line 85 of file SolvableType.h.

## ◆ isPatternPackage()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::isPatternPackage | ( |  | ) | const
| inline

Definition at line 86 of file SolvableType.h.

## ◆ productProvides()

template<class Derived>

Capability zypp::sat::SolvableType< Derived >::productProvides | ( |  | ) | const
| inline

Definition at line 87 of file SolvableType.h.

## ◆ isProductPackage()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::isProductPackage | ( |  | ) | const
| inline

Definition at line 88 of file SolvableType.h.

## ◆ isBlacklisted()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::isBlacklisted | ( |  | ) | const
| inline

Definition at line 90 of file SolvableType.h.

## ◆ isRetracted()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::isRetracted | ( |  | ) | const
| inline

Definition at line 91 of file SolvableType.h.

## ◆ isPtf()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::isPtf | ( |  | ) | const
| inline

Definition at line 92 of file SolvableType.h.

## ◆ isPtfMaster()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::isPtfMaster | ( |  | ) | const
| inline

Definition at line 93 of file SolvableType.h.

## ◆ isPtfPackage()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::isPtfPackage | ( |  | ) | const
| inline

Definition at line 94 of file SolvableType.h.

## ◆ buildtime()

template<class Derived>

Date zypp::sat::SolvableType< Derived >::buildtime | ( |  | ) | const
| inline

Definition at line 96 of file SolvableType.h.

## ◆ installtime()

template<class Derived>

Date zypp::sat::SolvableType< Derived >::installtime | ( |  | ) | const
| inline

Definition at line 97 of file SolvableType.h.

## ◆ asString()

template<class Derived>

std::string zypp::sat::SolvableType< Derived >::asString | ( |  | ) | const
| inline

Definition at line 99 of file SolvableType.h.

## ◆ asUserString()

template<class Derived>

std::string zypp::sat::SolvableType< Derived >::asUserString | ( |  | ) | const
| inline

Definition at line 100 of file SolvableType.h.

## ◆ identical() [1/2]

template<class Derived>

bool zypp::sat::SolvableType< Derived >::identical | ( | const Solvable & | rhs | ) | const
| inline

Definition at line 102 of file SolvableType.h.

## ◆ identical() [2/2]

template<class Derived>
template<class RDerived>

bool zypp::sat::SolvableType< Derived >::identical | ( | const SolvableType< RDerived > & | rhs | ) | const
| inline

Definition at line 104 of file SolvableType.h.

## ◆ sameNVRA() [1/2]

template<class Derived>

bool zypp::sat::SolvableType< Derived >::sameNVRA | ( | const Solvable & | rhs | ) | const
| inline

Definition at line 106 of file SolvableType.h.

## ◆ sameNVRA() [2/2]

template<class Derived>
template<class RDerived>

bool zypp::sat::SolvableType< Derived >::sameNVRA | ( | const SolvableType< RDerived > & | rhs | ) | const
| inline

Definition at line 108 of file SolvableType.h.

## ◆ dep_provides()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::dep_provides | ( |  | ) | const
| inline

Definition at line 110 of file SolvableType.h.

## ◆ dep_requires()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::dep_requires | ( |  | ) | const
| inline

Definition at line 111 of file SolvableType.h.

## ◆ dep_conflicts()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::dep_conflicts | ( |  | ) | const
| inline

Definition at line 112 of file SolvableType.h.

## ◆ dep_obsoletes()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::dep_obsoletes | ( |  | ) | const
| inline

Definition at line 113 of file SolvableType.h.

## ◆ dep_recommends()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::dep_recommends | ( |  | ) | const
| inline

Definition at line 114 of file SolvableType.h.

## ◆ dep_suggests()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::dep_suggests | ( |  | ) | const
| inline

Definition at line 115 of file SolvableType.h.

## ◆ dep_enhances()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::dep_enhances | ( |  | ) | const
| inline

Definition at line 116 of file SolvableType.h.

## ◆ dep_supplements()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::dep_supplements | ( |  | ) | const
| inline

Definition at line 117 of file SolvableType.h.

## ◆ dep_prerequires()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::dep_prerequires | ( |  | ) | const
| inline

Definition at line 118 of file SolvableType.h.

## ◆ dep()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::dep | ( | Dep | which_r | ) | const
| inline

Definition at line 119 of file SolvableType.h.

## ◆ operator[]()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::operator[] | ( | Dep | which_r | ) | const
| inline

Definition at line 120 of file SolvableType.h.

## ◆ provides()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::provides | ( |  | ) | const
| inline

Definition at line 123 of file SolvableType.h.

## ◆ conflicts()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::conflicts | ( |  | ) | const
| inline

Definition at line 125 of file SolvableType.h.

## ◆ obsoletes()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::obsoletes | ( |  | ) | const
| inline

Definition at line 126 of file SolvableType.h.

## ◆ recommends()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::recommends | ( |  | ) | const
| inline

Definition at line 127 of file SolvableType.h.

## ◆ suggests()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::suggests | ( |  | ) | const
| inline

Definition at line 128 of file SolvableType.h.

## ◆ enhances()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::enhances | ( |  | ) | const
| inline

Definition at line 129 of file SolvableType.h.

## ◆ supplements()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::supplements | ( |  | ) | const
| inline

Definition at line 130 of file SolvableType.h.

## ◆ prerequires()

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::prerequires | ( |  | ) | const
| inline

Definition at line 131 of file SolvableType.h.

## ◆ providesNamespace()

template<class Derived>

CapabilitySet zypp::sat::SolvableType< Derived >::providesNamespace | ( | const std::string & | namespace_r | ) | const
| inline

Definition at line 135 of file SolvableType.h.

## ◆ valuesOfNamespace()

template<class Derived>

CapabilitySet zypp::sat::SolvableType< Derived >::valuesOfNamespace | ( | const std::string & | namespace_r | ) | const
| inline

Definition at line 136 of file SolvableType.h.

## ◆ supportsLocales()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::supportsLocales | ( |  | ) | const
| inline

Definition at line 138 of file SolvableType.h.

## ◆ supportsLocale() [1/2]

template<class Derived>

bool zypp::sat::SolvableType< Derived >::supportsLocale | ( | const Locale & | locale_r | ) | const
| inline

Definition at line 139 of file SolvableType.h.

## ◆ supportsLocale() [2/2]

template<class Derived>

bool zypp::sat::SolvableType< Derived >::supportsLocale | ( | const LocaleSet & | locales_r | ) | const
| inline

Definition at line 140 of file SolvableType.h.

## ◆ supportsRequestedLocales()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::supportsRequestedLocales | ( |  | ) | const
| inline

Definition at line 141 of file SolvableType.h.

## ◆ getSupportedLocales()

template<class Derived>

LocaleSet zypp::sat::SolvableType< Derived >::getSupportedLocales | ( |  | ) | const
| inline

Definition at line 142 of file SolvableType.h.

## ◆ cpeId()

template<class Derived>

CpeId zypp::sat::SolvableType< Derived >::cpeId | ( |  | ) | const
| inline

Definition at line 144 of file SolvableType.h.

## ◆ mediaNr()

template<class Derived>

unsigned zypp::sat::SolvableType< Derived >::mediaNr | ( |  | ) | const
| inline

Definition at line 145 of file SolvableType.h.

## ◆ installSize()

template<class Derived>

ByteCount zypp::sat::SolvableType< Derived >::installSize | ( |  | ) | const
| inline

Definition at line 146 of file SolvableType.h.

## ◆ downloadSize()

template<class Derived>

ByteCount zypp::sat::SolvableType< Derived >::downloadSize | ( |  | ) | const
| inline

Definition at line 147 of file SolvableType.h.

## ◆ distribution()

template<class Derived>

std::string zypp::sat::SolvableType< Derived >::distribution | ( |  | ) | const
| inline

Definition at line 148 of file SolvableType.h.

## ◆ summary()

template<class Derived>

std::string zypp::sat::SolvableType< Derived >::summary | ( | const Locale & | lang_r = Locale() | ) | const
| inline

Definition at line 150 of file SolvableType.h.

## ◆ description()

template<class Derived>

std::string zypp::sat::SolvableType< Derived >::description | ( | const Locale & | lang_r = Locale() | ) | const
| inline

Definition at line 151 of file SolvableType.h.

## ◆ insnotify()

template<class Derived>

std::string zypp::sat::SolvableType< Derived >::insnotify | ( | const Locale & | lang_r = Locale() | ) | const
| inline

Definition at line 152 of file SolvableType.h.

## ◆ delnotify()

template<class Derived>

std::string zypp::sat::SolvableType< Derived >::delnotify | ( | const Locale & | lang_r = Locale() | ) | const
| inline

Definition at line 153 of file SolvableType.h.

## ◆ licenseToConfirm()

template<class Derived>

std::string zypp::sat::SolvableType< Derived >::licenseToConfirm | ( | const Locale & | lang_r = Locale() | ) | const
| inline

Definition at line 154 of file SolvableType.h.

## ◆ needToAcceptLicense()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::needToAcceptLicense | ( |  | ) | const
| inline

Definition at line 155 of file SolvableType.h.

## ◆ lookupStrAttribute() [1/2]

template<class Derived>

std::string zypp::sat::SolvableType< Derived >::lookupStrAttribute | ( | const SolvAttr & | attr | ) | const
| inline

Definition at line 158 of file SolvableType.h.

## ◆ lookupStrAttribute() [2/2]

template<class Derived>

std::string zypp::sat::SolvableType< Derived >::lookupStrAttribute | ( | const SolvAttr & | attr,
|  | const Locale & | lang_r ) const
| inline

Definition at line 159 of file SolvableType.h.

## ◆ lookupBoolAttribute()

template<class Derived>

bool zypp::sat::SolvableType< Derived >::lookupBoolAttribute | ( | const SolvAttr & | attr | ) | const
| inline

Definition at line 160 of file SolvableType.h.

## ◆ lookupIdAttribute()

template<class Derived>

detail::IdType zypp::sat::SolvableType< Derived >::lookupIdAttribute | ( | const SolvAttr & | attr | ) | const
| inline

Definition at line 161 of file SolvableType.h.

## ◆ lookupNumAttribute() [1/2]

template<class Derived>

unsigned long long zypp::sat::SolvableType< Derived >::lookupNumAttribute | ( | const SolvAttr & | attr | ) | const
| inline

Definition at line 162 of file SolvableType.h.

## ◆ lookupNumAttribute() [2/2]

template<class Derived>

unsigned long long zypp::sat::SolvableType< Derived >::lookupNumAttribute | ( | const SolvAttr & | attr,
|  | unsigned long long | notfound_r ) const
| inline

Definition at line 163 of file SolvableType.h.

## ◆ lookupCheckSumAttribute()

template<class Derived>

CheckSum zypp::sat::SolvableType< Derived >::lookupCheckSumAttribute | ( | const SolvAttr & | attr | ) | const
| inline

Definition at line 164 of file SolvableType.h.

## ◆ lookupLocation()

template<class Derived>

OnMediaLocation zypp::sat::SolvableType< Derived >::lookupLocation | ( |  | ) | const
| inline

Definition at line 165 of file SolvableType.h.

## ◆ id()

template<class Derived>

Solvable::IdType zypp::sat::SolvableType< Derived >::id | ( |  | ) | const
| inline

Definition at line 166 of file SolvableType.h.

## ◆ operator=() [1/2]

template<class Derived>

SolvableType & zypp::sat::SolvableType< Derived >::operator= | ( | const SolvableType< Derived > & |  | ) |
| protecteddefault

## ◆ operator=() [2/2]

template<class Derived>

SolvableType & zypp::sat::SolvableType< Derived >::operator= | ( | SolvableType< Derived > && |  | ) |
| protecteddefaultnoexcept

## Member Data Documentation

## ◆ const

template<class Derived>

Capabilities zypp::sat::SolvableType< Derived >::const { return satSolvable().dep_requires()

Definition at line 124 of file SolvableType.h.

The documentation for this class was generated from the following file:

- zypp/sat/SolvableType.h